Get optimization details for a specific Entitlement

Prev Next
Get
/entitlements/{id}/optimization

Returns optimization details for a specific Entitlement, including a suggested operation and suggested action removals based on usage data. Requires the Optimizer licensed feature.

Security
HTTP
Type bearer
Path parameters
id
string (uuid) Required

ID of the object.

Example12699e27-b584-464a-81ee-5b4784b6d425
Responses
200

Optimization details for the Entitlement.

Expand All
object

Optimization details and suggestions for an Entitlement based on usage data.

entitlement
object
id
string (uuid)

ID of the object.

Example4c07bc67-57ea-42dd-b702-c2d6c45419fc
name
string

Name of the object.

Exampleobject
notes
string

Notes for the object. Used for documentation purposes.

ExampleThis object has been created for test purposes.
created
string (date-time)

Create date.

updated
string (date-time)

Last update date.

readOnly
boolean

Whether the entity is protected from manual updates and deletes.

Examplefalse
tags
Array of string

Array of tags.

Example[ "developer", "api-created" ]
string
type
string

The type of the Entitlement.

Valid values[ "Network", "BrokeredRdp", "BrokeredSsh" ]
Default"Network"
ExampleNetwork
disabled
boolean

If true, the Entitlement will be disregarded during authorization.

Defaultfalse
site
string (uuid)

ID of the Site for this Entitlement.

Example4c07bc67-57ea-42dd-b702-c2d6c45419fc
siteName
string

Name of the Site for this Entitlement. For convenience only.

ExampleDefault Site
conditionLogic
string

Whether all the Conditions must succeed to have access to this Entitlement or just one.

Valid values[ "and", "or" ]
Default"and"
conditions
Array of string

List of Condition IDs applied to this Entitlement.

Min items1
string (uuid)
Example4c07bc67-57ea-42dd-b702-c2d6c45419fc
optimizationScore
string

Indicates how optimized this Entitlement is based on usage data. Actions or hosts/ports/types/methods marked as optimizationExempt are excluded from this calculation. Licensed feature.

Valid values[ "NotLinked", "Unused", "Overprovisioned", "InsufficientData", "NotInUse", "NotAnalyzed", "OptimizedWithExemptions", "Optimized" ]
Default"InsufficientData"
optimizationScorePercentage
integer

Numeric percentage score representing how optimized this Entitlement is based on usage data. Licensed feature.

actions
Array of object

List of all IP Access actions in this Entitlement.

object

IP Access action.

subtype
string

Type of the IP Access action. Required unless the action is exclude.

Valid values[ "icmp_up", "icmp_down", "icmpv6_up", "icmpv6_down", "udp_up", "udp_down", "tcp_up", "tcp_down", "ah_up", "ah_down", "esp_up", "esp_down", "gre_up", "gre_down", "http_up" ]
action
string

Applied action to the traffic.

Valid values[ "allow", "block", "alert", "exclude" ]
hosts
Array of string

Hosts to apply the action to. See admin manual for possible values.

Example[ "10.0.0.1", "10.0.0.0/24", "hostname.company.com", "dns://hostname.company.com", "aws://security-group:accounting" ]
string
ports
Array of string

Destination port. Multiple ports can be entered comma separated. Port ranges can be entered dash separated. Only valid for tcp, udp, ssh, and rdp subtypes

Example[ 80, "1024-65535" ]
string
types
Array of string

ICMP type. Only valid for icmp subtypes.

Example[ "0-255" ]
string
methods
Array of string (HttpMethod)

HTTP method. Only valid for http subtypes. Leave it empty to allow all types.

string
Valid values[ "GET", "HEAD", "POST", "PUT", "DELETE", "CONNECT", "OPTIONS", "TRACE", "PATCH", "MKCOL", "COPY", "MOVE", "PROPFIND", "PROPPATCH", "LOCK", "UNLOCK" ]
monitor
object

Only available for tcp_up and http_up subtypes. If enabled, Gateways will monitor this action for responsiveness and act accordingly. See admin manual for more details.

enabled
boolean
Defaultfalse
timeout
integer

Number of seconds the action needs to be unresponsive to mark the action unhealthy.

Default30
optimizationExemptHosts
Array of string

Hosts exempt from Entitlement Optimization analysis. Traffic to these hosts will not be considered when calculating the optimization score for this action. Uses the same format as hosts.

Example[ "10.0.0.1", "hostname.company.com" ]
string
optimizationExemptPorts
Array of string

Destination ports exempt from Entitlement Optimization analysis. Traffic on these ports will not be considered when calculating the optimization score for this action. Only valid for tcp, udp, ssh, and rdp subtypes. Uses the same format as ports.

Example[ 8080, "9000-9100" ]
string
optimizationExemptTypes
Array of string

ICMP types exempt from Entitlement Optimization analysis. Traffic of these types will not be considered when calculating the optimization score for this action. Only valid for icmp subtypes. Uses the same format as types.

Example[ "0-255" ]
string
optimizationExemptMethods
Array of string (HttpMethod)

HTTP methods exempt from Entitlement Optimization analysis. Traffic using these methods will not be considered when calculating the optimization score for this action. Only valid for http subtypes.

string
Valid values[ "GET", "HEAD", "POST", "PUT", "DELETE", "CONNECT", "OPTIONS", "TRACE", "PATCH", "MKCOL", "COPY", "MOVE", "PROPFIND", "PROPPATCH", "LOCK", "UNLOCK" ]
appShortcuts
Array of object (AppShortcut)

Array of App Shortcuts.

object

Publishes the configured URL as an app on the client using the display name as the app name.

name
string

Name for the App Shortcut which will be visible on the Client UI.

ExampleAccounting Software
description
string

Description for the App Shortcut which will be visible on the Client UI.

ExampleThis app will get you to the Accounting Software.
url
string

The URL that will be triggered on the OS to be handled. For example, an HTTPS URL will start the browser for the given URL.

Examplehttps://service.company.com
colorCode
integer

The color code of the shortcut on the client.

  • 1: Light Green
  • 2: Green
  • 3: Indigo
  • 4: Deep Purple
  • 5: Yellow
  • 6: Lime
  • 7: Light Blue
  • 8: Blue
  • 9: Amber
  • 10: Orange
  • 11: Cyan
  • 12: Teal
  • 13: Deep Orange
  • 14: Red
  • 15: Gray
  • 16: Brown
  • 17: Pink
  • 18: Purple
  • 19: Blue Gray
  • 20: Near Black
Minimum1
Maximum20
Default1
groupName
string

The group name this shortcut is to be grouped by

ExampleAccounting Applications
appShortcutScripts
Array of string

List of Entitlement Script IDs used for creating App Shortcuts dynamically.

string (uuid)
Example4c07bc67-57ea-42dd-b702-c2d6c45419fc
suggestedOperation
string

Suggested optimization operation for the Entitlement.

Valid values[ "Update", "Disable", "None" ]
actions
Array of object (OptimizationAction)

List of optimization actions with suggested removals based on usage analysis.

object

An IP access action with optimization analysis results for its hosts and ports/types.

action
string

Applied action to the traffic.

Valid values[ "allow", "block", "alert", "exclude" ]
subtype
string

Type of the IP Access action. Required unless the action is exclude.

Valid values[ "icmp_up", "icmp_down", "icmpv6_up", "icmpv6_down", "udp_up", "udp_down", "tcp_up", "tcp_down", "ah_up", "ah_down", "esp_up", "esp_down", "gre_up", "gre_down", "http_up" ]
hosts
Array of object (OptimizableValue)

Hosts with their optimization analysis results.

object

A single value (host, port, or type) with its optimization analysis metadata.

value
string

The host, port, or type value.

Example10.0.0.1
range
string

Optimization range classification for this value.

Valid values[ "Broad", "Partial", "None" ]
exempted
boolean

Whether this value is exempt from optimization analysis.

suggestedForRemoval
boolean

Whether this value is suggested to be removed based on usage analysis.

notAnalyzed
boolean

Whether this value could not be analyzed (unsupported host, or a port in an action with an unsupported host).

portsOrTypes
Array of object (OptimizableValue)

Ports or ICMP types with their optimization analysis results.

object

A single value (host, port, or type) with its optimization analysis metadata.

value
string

The host, port, or type value.

Example10.0.0.1
range
string

Optimization range classification for this value.

Valid values[ "Broad", "Partial", "None" ]
exempted
boolean

Whether this value is exempt from optimization analysis.

suggestedForRemoval
boolean

Whether this value is suggested to be removed based on usage analysis.

notAnalyzed
boolean

Whether this value could not be analyzed (unsupported host, or a port in an action with an unsupported host).

policiesLinked
Array of string

IDs of policies linked to this Entitlement.

Example[ "a1b2c3d4-e5f6-7890-abcd-ef1234567890" ]
string (uuid)
actionUsage
string

Overall usage classification across all actions in this Entitlement.

Valid values[ "NoUsage", "NoUnusedItems", "UnusedHostsOrPorts", "NotApplicable" ]
ExampleUnusedHostsOrPorts
broadRules
string

Whether broad IP ranges were detected across actions in this Entitlement.

Valid values[ "NoRangesDetected", "RangesDetected" ]
ExampleRangesDetected
recommendedDays
integer

Recommended number of days of usage data to consider for optimization.

Example30
remainingDays
integer

Number of days remaining until the optimization recommendation expires.

Example7
401

Token error. Login again.

object

Generic HTTP error.

id
string

Machine readable error code.

message
string

Human readable error details.

402

Insufficient license.

object

Generic HTTP error.

id
string

Machine readable error code.

message
string

Human readable error details.

403

Insufficient permissions to access this resource.

object

Generic HTTP error.

id
string

Machine readable error code.

message
string

Human readable error details.

404

The requested resource can not be found.

object

Generic HTTP error.

id
string

Machine readable error code.

message
string

Human readable error details.

406

Invalid 'Accept' header.

object

Generic HTTP error.

id
string

Machine readable error code.

message
string

Human readable error details.

412

Precondition failed. ZTP is not registered or Optimizer is not enabled.

object

Generic HTTP error.

id
string

Machine readable error code.

message
string

Human readable error details.

500

Unexpected server side error.

object

Generic HTTP error.

id
string

Machine readable error code.

message
string

Human readable error details.